#include<bits/stdc++.h>
#define ll long long
#define f first
#define s second
using namespace std;
const ll maxn=2e5+10;
ll n,m;
struct Edge
{
    ll to,p,c;
};
vector<Edge> edges[maxn];
bool visited[maxn];
ll Dijkstra(ll limit)
{
    priority_queue<pair<ll,ll>> pq;
    vector<ll> dist(n+1,LLONG_MAX/2);
    pq.push({0,1});
    dist[1]=0;
    while(!pq.empty())
    {
        ll curr=pq.top().s;
        ll path=-pq.top().f;
        pq.pop();
        if(dist[curr]<path) continue;
        for(auto e:edges[curr])
        {
            if(e.p>limit) continue;
            if(dist[e.to]>path+e.c)
            {
                dist[e.to]=path+e.c;
                pq.push({-dist[e.to],e.to});
            }
        }
    }
    if(dist[n]==LLONG_MAX/2) return 0;
    return dist[n];
}
ll bfs(ll limit)
{
    queue<ll> q;
    vector<ll> depth(n+1,0);
    vector<bool> visited(n+1,0);
    q.push(1);
    visited[1]=1;
    while(!q.empty())
    {
        ll curr=q.front();
        q.pop();
        for(auto e:edges[curr])
        {
            if(visited[e.to] || e.p>limit) continue;
            q.push(e.to);
            visited[e.to]=1;
            depth[e.to]=depth[curr]+1;
        }
    }
    return depth[n];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    ll mxp=0;
    for(ll i=0;i<m;i++)
    {
        ll u,v,tp,tc;
        cin>>u>>v>>tp>>tc;
        edges[u].push_back({v,tp,tc});
        edges[v].push_back({u,tp,tc});
        mxp=max(mxp,tp);
    }
    ll l=1,r=mxp+1;
    while(l!=r)
    {
        ll mid=(l+r)/2;
        if(bfs(mid)) r=mid;
        else l=mid+1;
    }
    cout<<l<<" "<<Dijkstra(l)<<"\n";
}
/*
5 7
1 3 1 1
1 5 4 5
2 4 3 4
2 5 1 2
1 2 1 6
3 5 2 5
4 5 1 1
*/




