#include<iostream>
#include<vector>
#include<queue>
#include<climits>
#define MAXN 200010
using namespace std;
vector<pair<int,pair<long long, long long>>> edges[MAXN];//{to,{p,w}}
priority_queue<pair<long long, pair<int,int>>> pq; //{p,{u,v}}
int parent[MAXN];
int sz[MAXN];
long long dist[MAXN];
int find(int curr)
{
    if(parent[curr]==curr)return curr;
    return parent[curr]=find(parent[curr]);//path optimization
}
void unite(int a, int b)
{
    a=find(a);
    b=find(b);
    if(a==b)return;
    if(sz[a]<sz[b])swap(a,b);//union by size
    sz[a]+=sz[b];
    parent[b]=a;
}
void dijkstra(int n, long long lim)
{
    for(int i=1;i<=n;i++)dist[i]=LLONG_MAX;
    dist[1]=0;
    priority_queue<pair<long long,int>> q;
    q.push({0,1});

    while(!q.empty())
    {
        long long val=-q.top().first;
        int curr=q.top().second;
        q.pop();

        if(val>dist[curr])continue;
        for(int i=0;i<edges[curr].size();i++)
        {
            int now=edges[curr][i].first;
            long long w=edges[curr][i].second.second;
            long long p=edges[curr][i].second.first;
            if(p>lim)continue;//skip unwanted edges

            if(val+w<dist[now])
            {
                dist[now]=val+w;
                q.push({-dist[now],now});
            }
        }
    }
}
int main()
{
    int n,m;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;

    for(int i=1;i<=n;i++)//initialize DSU
    {
        parent[i]=i;
        sz[i]=1;
    }

    for(int i=0;i<m;i++)
    {
        int u,v;
        long long p,w;
        cin>>u>>v>>p>>w;
        edges[u].push_back({v,{p,w}});
        edges[v].push_back({u,{p,w}});

        pq.push({-p,{u,v}});
    }

    long long ans=0;
    while(!pq.empty())//build MST
    {
        ans=-pq.top().first;
        int a=pq.top().second.first,b=pq.top().second.second;
        pq.pop();
        unite(a,b);
        if(find(1)==find(n))break;
    }

    dijkstra(n,ans);//run Dijkstra

    cout<<ans<<" "<<dist[n]<<"\n";
}
/*
5 7
1 2 1 1
1 3 2 3
2 3 3 1
2 4 1 2
2 5 1 3
3 5 1 1
4 5 1 2
*/
